#if !defined(__WCOPYHELP_H)
#define __WCOPYHELP_H

#define LNG_HLP_COPY          "Copy files (always disable moving)"
#define LNG_HLP_MOVE          "Move files"
#define LNG_HLP_OVERWRITE     "Overwrite existing files"
#define LNG_HLP_APPEND        "Append to existing files"
#define LNG_HLP_SKIP          "Skip all existing files"
#define LNG_HLP_DIFFONLY      "Copy/move different files only"
#define LNG_HLP_EXISTONLY     "Copy/move already existing files only"
#define LNG_HLP_NEWONLY       "Copy/move new files only"
#define LNG_HLP_CLEARATTR     "Set standard file attributes"
#define LNG_HLP_DIGITSET      "Use in new file name decimal digits only"
#define LNG_HLP_KEEPEXT       "Don't change extension when file already exists"
#define LNG_HLP_NOSOUND       "Silence mode"
#define LNG_HLP_USEPATH       "Use full path in [list]"
#define LNG_HLP_BINKSTYLE     "Use Bink style [list] format"
#define LNG_HLP_ADDHOME       "Add current folder to folder [list]"
#define LNG_HLP_EXTMASK       "Use '+' as any digit (f.e.: LINE++.LOG)"
#define LNG_HLP_FILESBBS      "Create/update FILES.BBS"
#define LNG_HLP_RECURSIVE     "Recursive subfolders scan"
#define LNG_HLP_TREE          "Create subfolders tree"
#define LNG_HLP_FLOPPY        "Prompt to diskette change when the disk is full"
#define LNG_HLP_REWRITE       "Remove copyed files from file [list]"
#define LNG_HLP_TRYRENAME     "Try rename first (when move files)"

#ifdef __WIN32__
#define LNG_HLP_DOSNAMES      "Use short '8.3' file names"
#define LNG_HLP_OEM2ANSI      "File/folder lists in OEM (DOS) character set"
#endif

#define LNG_HLP_USAGE0        "Usage:\n"
#define LNG_HLP_USAGE1        " WCOPY [path]files[,[path]files[, ... ]] [destination] [switches]\n"
#define LNG_HLP_USAGE2        "         File or [list]. Wildcards allowed in filenames and paths.\n"
#define LNG_HLP_USAGE3        "                 Examples: *.C, \\VC\\[VC.LST], C:\\*\\*.CPP, [DIR.FRQ][*.REQ])\n"

#define LNG_HLP_USAGE4        "\nValid switches:\n"
#define LNG_HLP_NOENV         "NOENV            - Don't process %WCOPY% environment variable"
#define LNG_HLP_EXCLUDE       "-[:]<filemask>   - Exclude <filemask>"
#define LNG_HLP_ADDRESS       "@[:]<address>    - FTN address for macroses =A, =B and =L"
#define LNG_HLP_BASEADDR      "@@[:]<address>   - Base FTN address for short form in /@"
#define LNG_HLP_REN           "REN[:]<filemask> - Rename destination file using <filemask>"
#define LNG_HLP_LOG           "LOG[:]<file>     - Log file name"
#define LNG_HLP_MSG           "MSG[:]<file>     - Report file name"
#define LNG_HLP_TRY           "TRY[:]<n>        - Try to create destination <n> times only"
#define LNG_HLP_LIMIT         "LIMIT[:]<size>   - Copy <size> bytes maximum"
#define LNG_HLP_IF            "IF<t>.<op>.<arg> - Only matched files (<t> - SIZE, DATE or TIME)"

#define LNG_HLP_USAGE5        "\nValid <op> in /IF switch:\n"
#define LNG_HLP_IF_LT         "LT - less than"
#define LNG_HLP_IF_LE         "LE - less or equal"
#define LNG_HLP_IF_EQ         "EQ - equal"
#define LNG_HLP_IF_NE         "NE - not equal"
#define LNG_HLP_IF_GE         "GE - greater or equal"
#define LNG_HLP_IF_GT         "GT - greater than"

#define LNG_HLP_USAGE6        "\nValid <arg> in /IF switch:\n"
#define LNG_HLP_IF_FILE       "filename          - size, date or time of <filename>"
#define LNG_HLP_IF_DATE       "dd/mm/yy[yy]      - date as constant (/IFDATE only)"
#define LNG_HLP_IF_DAYS       "{+|-}days         - relative date (/IFDATE only)"
#define LNG_HLP_IF_TIME       "[+|-]hh[:mm[:ss]] - time (/IFTIME only)"
#define LNG_HLP_IF_SIZE       "number[K|M|G]     - size as constant (/IFSIZE only)"

#define LNG_HLP_USAGE7        "\nMacroses in filenames (Address must be given in /@ switch):\n"
#define LNG_HLP_MACRO_A       "A - LFN box (z.n.f.p)"
#define LNG_HLP_MACRO_B       "B - box (zznnnfff.pp)"
#define LNG_HLP_MACRO_L       "L - BSO file ([.zzz]\\nnnnffff[.PNT\\0000pppp])"
#define LNG_HLP_MACRO_D       "D - day of month"
#define LNG_HLP_MACRO_M       "M - month"
#define LNG_HLP_MACRO_C       "C - year"
#define LNG_HLP_MACRO_Y       "Y - two digit year (without century)"
#define LNG_HLP_MACRO_H       "H - hour"
#define LNG_HLP_MACRO_T       "T - minute"
#define LNG_HLP_MACRO_S       "S - second"

#define LNG_HLP_EXAMPLES      "Examples:\n"
#define LNG_HLP_EX_S1         "C:\\WORK\\*.* C:\\BACKUP"
#define LNG_HLP_EX_T11        "simple copy with"
#define LNG_HLP_EX_T12        "default switches"
#define LNG_HLP_EX_S2         "C:\\OUT\\*.?UT C:\\BOX /REN*.PKT"
#define LNG_HLP_EX_T21        "copy BSO packets with rename"
#define LNG_HLP_EX_T22        "it to .PKT standard extension"
#define LNG_HLP_EX_S3         "C:\\DATA[C:\\VC.LST] A:\\ /D"
#define LNG_HLP_EX_T31        "copy files listed in VC.LST"
#define LNG_HLP_EX_T32        "with dupes control"
#define LNG_HLP_EX_S4         "[DIR.FRQ][A*.LST] \\T-MAIL\\BOX\\"
#define LNG_HLP_EX_T41        "copy files listed in A*.LST"
#define LNG_HLP_EX_T42        "from dirs listed in DIR.FRQ"
#define LNG_HLP_EX_S5         "OUT[=L.?LO] BOX\\=B /B /@464/991"
#define LNG_HLP_EX_T51        "copy files from BSO storage"
#define LNG_HLP_EX_T52        "to short box"
#define LNG_HLP_EX_S6         "C:\\*.LST,D:\\*.LST E:\\LST /R /M"
#define LNG_HLP_EX_T61        "move all LST files from all"
#define LNG_HLP_EX_T62        "subfolders on C: and D:"
#define LNG_HLP_EX_S7         "C:\\WORK\\*.* A:\\ /T /8"
#define LNG_HLP_EX_T71        "backup entire subtree using"
#define LNG_HLP_EX_T72        "short filenames"

#endif